#include "auxiliaire.h"
#include "stockex.h"
#include "good.h"
#include "queue.h"
#include <stdio.h>
#include <string.h>
#define MAX_TRANSACTION 100

// Fonction permettant de transformer un wallet en valeur HONEY
unsigned int wallet__value(struct wallet w)
{
  unsigned int value = 0;
  for(int i =  0; i < MAX_GOOD; i ++)
    {
      value = value + w.data[i]*good__value(i);
    }
  return value;
}

// Retourne 1 si la différence est positive après nbr_times de fois la transac
int wallet_negative(const struct teddy* economiste, const struct transac* test)
  {
    struct wallet teddy_wallet = economiste->initialisation;
    struct wallet sortie = transac__in_wallet(test);
    for(int i=0; i<MAX_GOOD; i=i+1){
      int valeur = teddy_wallet.data[i]-sortie.data[i];
      if(valeur<0){
        return 0;
      }
    }
    return 1;
  }

//Retourne le nombre maximal de transactions possibles
int maximum_transaction(struct teddy* economiste, const struct transac* test)
  {
    int max_nbr_transac=0;
    struct teddy* test_teddy = economiste;
    struct wallet sortie = transac__in_wallet(test);
    int nbr_table[MAX_GOOD];
    for(int i = 0 ; i<MAX_GOOD; i=i+1){
      if(sortie.data[i]==0){
        nbr_table[i]=MAX_TRANSACTION;
      }
      else{
        nbr_table[i]=test_teddy->initialisation.data[i]/sortie.data[i];
      }
    }
    int min=nbr_table[0];
    for(int i=0; i<MAX_GOOD; i=i+1){
      if (nbr_table[i]<=min) {
        min=nbr_table[i];
      }
    }
    max_nbr_transac=min;
    return max_nbr_transac;
  }

// Permet de choisir une transaction aléatoirement tout en vérifiant que l'ours peut explorer ou non
const struct transac *choose_transaction(struct teddy* t,int stockex_number)
{
  int  nbr_transac = stockex__num_transactions(t->place);
  if(t->nbr_place_visited==stockex_number)
  {
    int nbr_transac_ala = rand()%nbr_transac;
    const struct transac* transac = stockex__transaction(t->place,nbr_transac_ala);
    t->place=(struct stockex*) transac__next_stockex(transac);
    return transac;
  }
  int transaction_available;
  for(int i = 0; i < nbr_transac; i ++)
  {
    transaction_available = 1; //on initialise le booléen à vrai
    int j =0;
    size_t jbis = 0;
    while(j < t->nbr_place_visited && jbis < stockex__num_transactions(t->place))
    {
      if(t->place_visited[j]==transac__next_stockex(stockex__transaction(t->place,jbis)))
        transaction_available=0; //le booléens devient nul le teddy a déjà visité la place suivante
      j ++;
      jbis ++;
    }
    if(transaction_available)
    {
      const struct transac* transac = stockex__transaction(t->place,i);
      char name[10];
      sprintf(name,"%s",stockex__name(transac__next_stockex(transac)));
      t->place=(struct stockex*) transac__next_stockex(transac);
      t->place_visited[t->nbr_place_visited]=(struct stockex*) transac__next_stockex(transac);
      t->nbr_place_visited ++;
      //free(name);
      return transac;
    }
  }
  int nbr_transac_ala = rand()%nbr_transac;//si on arrive ici, aucune nouvelle place ne peut_être visité on choisit aléatoirement
  const struct transac* transac = stockex__transaction(t->place,nbr_transac_ala);
  t->place=(struct stockex*) transac__next_stockex(transac);
  return transac;
}

//Permet de calculer la table permettant de trouver la meilleure transaction
int* calculate_tab_mul(struct teddy* economiste)
{
  for(size_t i = 0; i < stockex__num_transactions(economiste->place); i ++){
    struct wallet wallet_in = transac__in_wallet(stockex__transaction(economiste->place, i));
    struct wallet wallet_out = transac__out_wallet(stockex__transaction(economiste->place, i));
    int value_wallet_in = 0;
    int value_wallet_out = 0;
    for(int j = 0; j < MAX_GOOD; j++){
      value_wallet_in = value_wallet_in + good__value(j+1)*wallet_in.data[j];
      value_wallet_out = value_wallet_out + good__value(j+1)*wallet_out.data[j];
    }
    tab_values[i] = value_wallet_out - value_wallet_in;
    tab_times[i] = maximum_transaction(economiste,stockex__transaction(economiste->place,i));
    tab_mul[i] = tab_values[i]*tab_times[i];
  }
  return tab_mul;
}

//Permet de tester le type d'un teddy (normal)
int is_normal(struct teddy* t)
{
  int type = t->type;
  if(type==0)
    return 1;
  return 0;
}

//Permet de tester le type d'un teddy (malin)
int is_smart(struct teddy* t)
{
  int type = t->type;
  if(type==1)
    return 1;
  return 0;
}

//Permet de trouver le maximum dans un tableau
int rang_max(int tab[MAX_TRANSACTION], int rang_dernier)
{
  int max = tab[0];
  int max_position=0;
  for(int i = 0; i < rang_dernier; i ++){
    if(tab[i] > max){
      max = tab[i];
      max_position=i;
    }
  }
  return max_position;
}

