#include "loop.h"

// Global seed for the random number generator
static int seed = 0;
static int turn_number= 1000;
static int player_number= 20;
////////////////////////////////////////////////////////////////
// Function for parsing the options of the program
// Currently available options are :
// -s <seed> : sets the seed
// -m <turn_number> : sets the turn number
// -n <player_number> : sets the player number
void parse_opts(int argc, char* argv[]) {
  int opt;
  while ((opt= getopt(argc,argv,"s:m:n:")) != -1) {
    switch (opt) {
    case 's':
      seed = atoi(optarg);
      break;
    case 'm':
      turn_number= atoi(optarg);
      break;
    case 'n':
      player_number= atoi(optarg);
      break;
    default: /* '?' */
      fprintf(stderr, "Usage : %s [-s seed] [-n player_number] [-m turn_number]\n",argv[0]);
      exit(EXIT_FAILURE);
      }
  }
  if (player_number > 20){
    player_number=20;
  }
  if(stockex_number > 100){
    stockex_number=100;
  }
}


////////////////////////////////////////////////////////////////


int main(int argc, char* argv[])
{
  parse_opts(argc,argv);
  srand(seed);
  stockex_number=rand()%MAX_STOCKEX;
  printf("Seed : %d\n", seed);
  printf("Turn_number : %d\n",turn_number);
  printf("Player_number : %d\n",player_number);
  printf("Stockex_number : %d\n",stockex_number);
  if (player_number==0 || turn_number==0 || stockex_number==0) {
    printf("Le jeu est terminé, il n'y a pas d'ours, de stockex ou de temps \n");
    return 0;
  }
  const struct stockex* tab_stockex = starting_stockex();
  struct queue queue_game = fill_queue(player_number, tab_stockex); // Création de la queue initiale
  int global_time = 0;
  while (global_time < turn_number){
    struct teddy* active_teddy = queue__pop(&queue_game);//On prend le premier ours
    global_time = global_time+active_teddy->priority_teddy; //On actualise le temps général avec le temps de l'ours avant le jeu
    struct play active_teddy_play=which_transac(active_teddy, stockex_number);
    active_teddy->initialisation=active_teddy_play.transac; //On fait faire N fois une transaction à l'ours
    int time_spent = active_teddy_play.time; //On actualise la priorité de l'ours
    queue__push(&queue_game,time_spent, active_teddy); //On remet l'ours dans la queue
  }
  display_results(&queue_game,player_number);
  free_queue();
  free(queue_init);
}
