#include "stockex.h"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>

struct stockex Catane1;
struct stockex Catane2;

//Permet de free les différents malloc
void free_name()
{
  for(int i=2;i<stockex_number;i++){
    if(name_stockex[i]!=NULL){
      free(name_stockex[i]);
    }
  }
  free(created_stockex);
}

//Permet de générer les noms des places d'échanges
void fill_name_stockex(int stockex_number)
{
  name_stockex[0]="Catane";
  name_stockex[1]="Palerme";
  for(int i = 2; i < stockex_number; i ++)
    {
      name_stockex[i] = malloc(11);
      sprintf(name_stockex[i],"Stockex_%d",i+1);
    }
}

//Permet de lier des places d'échanges
void link_transac(struct stockex tab_stockex[], int stockex_number)
{
  for(int i = 0; i < stockex_number; i ++)
    {
      if(i<stockex_number-1){
        tab_stockex[i].transaction_tab[0].next_place = &tab_stockex[i+1];
      }
      else {
        tab_stockex[i].transaction_tab[0].next_place = &tab_stockex[0];
      }
      for(size_t j = 1; j < tab_stockex[i].length; j ++){
        size_t nbr_stockex = rand()%stockex_number;
        tab_stockex[i].transaction_tab[j].next_place = &tab_stockex[nbr_stockex];
      }
    }
}

//Permet de creer un wallet aléatoire
struct wallet random_wallet()
{
  struct wallet a ={{rand() %MAX_HONEY, rand() %MAX_MONKEY_WRENCH, rand() %MAX_OUTBOARD_MOTOR}};
  return a;
}

//Permet d'initialiser une place d'échange
void starting_stockex2(struct stockex* Catane)
{
  size_t length_trans=rand()%MAX_TRANSACTION;
  if(length_trans==0){length_trans=1;}
  struct transac* transaction_tab[length_trans];
  for(size_t j = 0 ; j <length_trans ; j=j+1)
    {
      struct wallet a = random_wallet();
      struct wallet b = random_wallet();
      for(int k = 0; k < MAX_GOOD; k=k+1){
        if(a.data[k] > b.data[k]){
          a.data[k] = a.data[k] - b.data[k];
          b.data[k] = 0;
        }
        else{
          b.data[k] = b.data[k] - a.data[k];
          a.data[k] = 0;
        }
      }
      struct transac c; //création transaction évitant malloc
      c.wallet_in = a;
      c.wallet_out = b;
      c.actual_place = Catane;
      c.next_place = Catane;
      transaction_tab[j]=&c;
    }
  Catane->length=length_trans;
  Catane->mark=0;
  for (size_t i = 0; i < length_trans; i = i + 1) {
    Catane->transaction_tab[i] = *transaction_tab[i];
  }
}

//Permet de creer des places d'échanges
const struct stockex* starting_stockex()
{
  fill_name_stockex(stockex_number);
  created_stockex = malloc(stockex_number*(sizeof(struct stockex)+8));
  for(int i = 0; i < stockex_number; i ++){
    created_stockex[i].name = name_stockex[i];
    starting_stockex2(&created_stockex[i]);
  }
  link_transac(created_stockex, stockex_number);
  atexit(free_name);
  return created_stockex;
}



// The name of the stock exchange
const char* stockex__name(const struct stockex* s)
{
  return  s->name;
}

// Iterator on transactions : the first function returns the number
// `n` of available transactions, and the second accesses them with
// indices ranging between 0 and n-1.
size_t stockex__num_transactions(const struct stockex* t)
  {
   return t->length;
  }

const struct transac* stockex__transaction(const struct stockex* t, size_t num)
  {
    return &t->transaction_tab[num];
  }

// The goods bought by the stock exchange
struct wallet transac__in_wallet(const struct transac* s)
  {
   return s->wallet_in;
  }

// The goods sold by the stock exchange
struct wallet transac__out_wallet(const struct transac* s)
  {
    return s->wallet_out;
  }

// The stock exchange where the transaction is done
const struct stockex* transac__stockex(const struct transac* s)
{
  return s->actual_place;
}

// The stock exchange reached after the transaction
const struct stockex* transac__next_stockex(const struct transac* s)
{
  return s->next_place;
}
