#ifndef __STOCKEX__
#define __STOCKEX__
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include "good.h"

#define MAX_GOOD 3
#define MAX_HONEY 1000
#define MAX_MONKEY_WRENCH 100
#define MAX_OUTBOARD_MOTOR 10
#define MAX_TRANSACTION 100
#define MAX_STOCKEX 100

//Permet d'initialiser les noms des places d'échanges
char* name_stockex[MAX_STOCKEX];

// The starting stock exchange * stockex_number
const struct stockex* starting_stockex();

//Initialise le nombre de places d'échanges
extern int stockex_number;

// The type representing transactions
struct transac{
 struct wallet wallet_in;
 struct wallet wallet_out;
 struct stockex* actual_place;
 struct stockex* next_place;
};

// The type representing stock exchanges length = nombre de transactions
struct stockex{
    char *name ;
    size_t length;
    struct transac transaction_tab[MAX_TRANSACTION];
    int mark;
};

//Permet de lier des transactions
void link_transac(struct stockex* tab_stockex, int stockex_number);

//Permet de creer un portefeuille aléatoire
struct wallet random_wallet();

//Permet de donner des noms aux places
void fill_name_stockex(int stockex_number);

//Initialiser une place d'échange
struct stockex* created_stockex;

// The name of the stock exchange
const char* stockex__name(const struct stockex* s);

// Iterator on transactions : the first function returns the number
// `n` of available transactions, and the second accesses them with
// indices ranging between 0 and n-1.
size_t  stockex__num_transactions(const struct stockex* t);

const struct transac* stockex__transaction(const struct stockex* t, size_t num);

// The goods bought by the stock exchange
struct wallet         transac__in_wallet(const struct transac* s);

// The goods sold by the stock exchange
struct wallet         transac__out_wallet(const struct transac* s);

// The stock exchange where the transaction is done
const struct stockex* transac__stockex(const struct transac* s);

// The stock exchange reached after the transaction
const struct stockex* transac__next_stockex(const struct transac* s);

#endif
